import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;


public class TimeVisual extends GenericServlet { 

   static PrintWriter out = null; // Jan 8.

   public void service(ServletRequest req, ServletResponse res)
       throws ServletException, IOException {

//       System.out.println("Enter the servlet TimeVisual...");
       res.setContentType("text/html");
       out = new PrintWriter(res.getOutputStream());
       int count     = 0;
       String userID = req.getParameter("userID");
       String applID = req.getParameter("applID");
       String totalExecFlag   = req.getParameter("totalExecFlag");
       String DrepIP  = req.getParameter("DrepIP");
       String DrepPort= req.getParameter("DrepPort");
       String DrepDBA = req.getParameter("DrepDBA");
       System.out.println("In TimeVisual servlets:" + userID + " " +applID + " " + totalExecFlag + " " + DrepIP + " " + DrepPort + " " + DrepDBA); 

	// flag="false", need read total exec time, "true" otherwise skip the record, 
	// the total exec time will be calculated by TimeVisual.class

//System.out.println("userID=" + userID + " applID=" + applID + " flag=" + totalExecFlag);
       String query = "Select ModuleName, TaskNo, ExeTime, Unit, TotalTask from time_"
		     + userID.trim() + "_" + applID.trim();

       ResultSet rs = null;
     try { 
        Class.forName("COM.imaginary.sql.msql.MsqlDriver");
        String url = "jdbc:msql://" + DrepIP + ":" + DrepPort + "/VDCE_TABLES";
//        String url = "jdbc:msql://128.230.61.2:4333/VDCE_TABLES";
	System.out.println("url : " + url);
        Connection con = DriverManager.getConnection(url, DrepDBA, "");
        Statement sqlstmt = con.createStatement();
	System.out.println(query);
        rs = sqlstmt.executeQuery(query);

   	boolean flag = false;
	while (rs.next()) {
	     String moduleName = rs.getString(1);
	     String tmp1 = null;
	     String tmp  = null;
	     if ((! moduleName.equals("Total"))
		 && (! moduleName.equals("Setup"))) {
                 tmp = moduleName + "_" + rs.getString(2) + " " + rs.getString(3) + "_";
	      }
	     else
                 tmp = moduleName + " " + rs.getString(3) + "_";

	     tmp1 = rs.getString(4);
	     count = Integer.parseInt(rs.getString(5));
	     if ( ! flag) {
		 flag = true;
		 count ++; 	// setUp time
                 out.println(count);
	      }
	     if (((totalExecFlag.equals("true")) && (! moduleName.equals("Total"))) 
		|| (totalExecFlag.equals("false"))) {
	          if (tmp1.equals("1"))
		      out.println(tmp + "us");
	          else if (tmp1.equals("3"))
		      out.println(tmp + "sec.");
	          else if (tmp1.equals("4"))
		      out.println(tmp + "hour");
	          else 
		      out.println(tmp + "ms"); //default is milisec.
//		 System.out.println(tmp);
	      }		// otherwise, skip the record for total exec time
         }
//	System.out.println("going to finish");
	rs.close();
	sqlstmt.close();
        out.flush();
        out.close();
	con.close();
      } catch (Exception e) {
               System.out.println(e.getMessage());
               e.printStackTrace();
          }
//       System.out.println("exit from the servlet TimeVisual...");
    }

    public String getServletInfo() {
        return " servlet for getting Execution Time data from database";
    }
}
